###########################################################
## Libraries
###########################################################
library(monoProc)
library(XLConnect)
###########################################################



###########################################################
## Load excel file
###########################################################
wb        = loadWorkbook("ret_prediction.xlsx", create = FALSE)
ret_cph   = readWorksheet(wb, sheet = "Method2 vs Method1_sorted", startRow = 0, endRow = 45, startCol = 4, endCol = 4)
ret_halle = readWorksheet(wb, sheet = "Method2 vs Method1_sorted", startRow = 0, endRow = 45, startCol = 5, endCol = 5)

mz   = readWorksheet(wb, sheet = "Method2 vs Method1_sorted", startRow = 0, endRow = 45, startCol = 6, endCol = 6)


ret_cph     = as.numeric(as.matrix(ret_cph))
ret_halle   = as.numeric(as.matrix(ret_halle))
mz   = as.numeric(as.matrix(mz))

temp = !(is.na(ret_cph) | is.na(ret_halle))
ret_cph =     ret_cph[temp]
ret_halle = ret_halle[temp]
mz=mz[temp]





rm(wb,temp)
###########################################################



###########################################################
## Make normal and monotonic fit
###########################################################
fit = loess(formula = ret_halle~ret_cph, span=0.57, degree=2, iterations=10, trace.hat = c("exact"))

fit_mono = monoproc(fit, bandwidth = 0.0001, mono1 = "increasing", gridsize=1000)
###########################################################



###########################################################
## Plot the fits
###########################################################
plot(ret_cph/60,ret_halle/60,main='Retention time conversion between systems',xlab="Rt (cph)",ylab="Rt (Halle)",pch=20)

#plot(fit)
#ret_halle_pred = predict(fit, seq(from=0, to=max(ret_cph,na.rm=TRUE), by=0.1))
#lines(seq(from=0, to=max(ret_cph,na.rm=TRUE), by=0.1),ret_halle_pred)
lines(fit_mono@fit@x/60,fit_mono@fit@y/60,col=2)


#rm(ret_halle_pred)
###########################################################




###########################################################
## plot deviation
###########################################################
fit_mono_pred = monoproc(fit, bandwidth = 0.0001, mono1 = "increasing", gridsize=1000,xx=ret_cph)
pred_y    = fit_mono_pred@fit@y

plot(ret_halle,ret_halle-pred_y, main="Deviation")

rm(fit_mono_pred)
###########################################################




###########################################################
## Select some values to predict with the monotonic model
###########################################################
#pred_x = c(1,2,3,4,5,6)
#fit_mono_pred = monoproc(fit, bandwidth = 0.0001, mono1 = "increasing", gridsize=1000,xx=pred_x)
#pred_y    = fit_mono_pred@fit@y
#rm(fit_mono_pred)
###########################################################



