xset_simple_map_merged_g_r_g = group(xset_simple_map_merged_g_r, minsamp=1, minfrac = 1, mzwid = 0.02, bw=30)



##############################################
## Getting matching ret times
##############################################

result=rtMatch_ByIndex(xset_merged_office_plasma_original,xset_simple_map_merged_g_r_g)

select=apply(result$result_mz,1,function(x) all(!is.na(x)))
result_rt=result$result_rt[select,]
result_mz=result$result_mz[select,]

ppm = ((result_mz[,2]-result_mz[,1])/result_mz[,1])*1E6
ppm_lim= 30

#nrow(result_mz[abs(ppm)<ppm_lim,])
#nrow(result_mz)





##############################################
## Make fit to Office plasma
##############################################
## Make normal and monotonic fit
fit_office = loess(formula = result_rt[,1]~result_rt[,2], span=0.1, degree=2, iterations=10, trace.hat = c("exact"))
fit_office_mono = monoproc(fit_office, bandwidth = 0.0001, mono1 = "increasing", gridsize=1000)



## Plot full mapping features and curve
plot(result_rt[,2]/60,result_rt[,1]/60, main="Retention time conversion between systems",xlab="RT (Cph)", ylab="RT (Halle)", pch=20,col='blue',xlim=c(0,6),ylim=c(0,16),cex=1)

pred_x = seq(from=0, to=6, by=0.01)*60
fit_mono_pred = monoproc(fit_office, bandwidth = 0.0001, mono1 = "increasing", gridsize=1000,xx=pred_x)
pred_y    = fit_mono_pred@fit@y
rm(fit_mono_pred)

lines(pred_x/60,pred_y/60,col='blue')





## Plot manual mapping features and curve
points(ret_cph/60,ret_halle/60,main='Retention time conversion between systems',xlab="Rt (cph)",ylab="Rt (Halle)",pch=15,col=paste(rgb(t(col2rgb('red')),maxColorValue=255),sprintf("%x", 255) ,sep='',collapse=''),xlim=c(0,6),ylim=c(0,16),cex=0.7)

pred_x = seq(from=0, to=6, by=0.01)*60
fit_mono_pred = monoproc(fit, bandwidth = 0.0001, mono1 = "increasing", gridsize=1000,xx=pred_x)
pred_y    = fit_mono_pred@fit@y
rm(fit_mono_pred)

lines(pred_x/60,pred_y/60,col='red')




# source("http://www.anthro.utah.edu/~rogers/datanal/R/scatboot.r")
# temp=as.data.frame(cbind(Cph=ret_cph/60,Halle=ret_halle/60))
# 
# sb <- with(temp, scatboot(Cph, Halle, confidence=0.99, degree=2,span=0.57))
# scatboot.plot(sb, xlab="CPh", ylab="Halle")
