library( Hmisc) 

match_right=c()
match=c()
Rsq=numeric()

mzwid=seq(from=0.001,to=0.005,by=0.001)
mzwid=c(mzwid,seq(from=0.005,to=0.1,by=0.005))

for (i2 in 1:length(mzwid)){


xset_simple_map_merged_g_r_g = group(xset_simple_map_merged_g_r, minsamp=1, minfrac = 1, mzwid = mzwid[i2], bw=30)



##############################################
## Getting matching ret times
##############################################
result_rt = matrix(data=NA,nrow=length(xset_simple_map_merged_g_r_g@groupidx), ncol=3)
result_mz = matrix(data=NA,nrow=length(xset_simple_map_merged_g_r_g@groupidx), ncol=3)
samp_a = 2
samp_b = 1
samp_list = xset_simple_map_merged_g_r_g@peaks[,"sample"]

for (i in 1:length(xset_simple_map_merged_g_r_g@groupidx)){
  groupidx = xset_simple_map_merged_g_r_g@groupidx[[i]]
  group_vec = as.logical(matrix(data=FALSE,nrow(xset_simple_map_merged_g_r_g@peaks)))
  group_vec[groupidx]=TRUE
  
  result_rt[i,1] = mean(xset_merged_office_plasma_original@peaks[samp_list==samp_a & group_vec,"rt"])
  result_rt[i,2]=  mean(xset_merged_office_plasma_original@peaks[samp_list==samp_b & group_vec,"rt"])
  result_rt[i,3] = mean(xset_simple_map_merged@peaks[samp_list==samp_a & group_vec,"rt"])
  
  result_mz[i,1] = mean(xset_simple_map_merged@peaks[samp_list==samp_a & group_vec,"mz"])
  result_mz[i,2]=  mean(xset_simple_map_merged@peaks[samp_list==samp_b & group_vec,"mz"])
  result_mz[i,3] = mean(xset_simple_map_merged@peaks[samp_list==samp_a & group_vec,"mz"])
}


select=apply(result_mz,1,function(x) all(!is.na(x)))
result_rt=result_rt[select,]
result_mz=result_mz[select,]

ppm = ((result_mz[,1]-result_mz[,2])/result_mz[,1])*1E6
ppm_lim= 30

match_right[i2]=nrow(result_mz[abs(ppm)<ppm_lim,])
match[i2]=nrow(result_mz)


reg1 <- lm(result_rt[,2]~result_rt[,3])
Rsq[i2] = summary(reg1)$r.squared

}






par(mar=c(5,4,4,5)+.1)
plot(mzwid,match,type="o",col="red",ylab='# features matched',xlab='mzwid',pch=20)

par(new=TRUE)
plot(mzwid, match-match_right,type="o",col="blue",xaxt="n",yaxt="n",xlab="",ylab="",pch=20)
axis(4)

mtext("# Mis-match",side=4,line=3)
legend("bottomright",col=c("red","blue"),lty=1,legend=c("# features matched","# Mis-match"),bty='n',cex=0.7)








##############################################
## Plot R squared
##############################################
plot(mzwid,Rsq,pch=20,type='o')

##############################################


